Joshua

Centos/Linux 下升级python2.7至3.5.0

(一) 安装Python3.5

(1)在安装python之前,因为linux系统下默认没有安装wget,gcc,首先安装wget,gcc:

1[root@node6 python_scripts]#yuminstallwget2[root@node6 python_scripts]#yuminstallgcc

(2)安装依赖:

!!!在编译之前需要安装一些必须的依赖,否则当报错的时候还得重新编译 

yuminstallopenssl-devel  -yyuminstallzlib-devel  -y

(3)利用wget下载python3.5.0的安装文件并解压缩:

1[root@node6 python_scripts]#wgethttps://www.python.org/ftp/python/3.5.0/Python-3.5.0.tgz2[root@node6 python_scripts]#ls3Python-3.5.0.tgz4[root@node6 python_scripts]#tarxvf Python-3.5.0.tgz 5[root@node6 python_scripts]#ls6Python-3.5.0Python-3.5.0.tgz7[root@node6 Python-3.5.0]# cd Python-3.5.0

(4)编译:

1[root@node6 Python-3.5.0]# ./configure –prefix=/usr/local/python3.52[root@node6 Python-3.5.0]#make3[root@node6 Python-3.5.0]#makeinstall4[root@node6 Python-3.5.0]mv/usr/bin/python /usr/bin/python_bak5[root@node6 Python-3.5.0]ln-s /usr/local/python3.5/bin/python3.5/usr/bin/python

(5)此时执行phthon可以看到3.5已经运行:

1[root@node6 python_scripts]# python2Python3.5.0(default, Jul272016,09:34:49) 3[GCC4.8.520150623(Red Hat4.8.5-4)] on linux4Type”help”,”copyright”,”credits”or”license”formore information.5>>>

(6) 此时yum的运行会报错,如下操作可以恢复yum:

修改yum文件

1、cd /usr/bin2、ls-lyum*

会显示出“yum、yum-builddep、yum-config-manager、yum-debug-dump、yum-debug-restore、yumdownloader、yum-groups-manager”这7个yum开头的文件,这7个文件都是脚本文件,其第一行为:

#!/usr/bin/python

#!/usr/bin/python -tt

将“python”改为“python2.7”。

我们试着安装一个文件:

[root@vnode33 bin]# yum install tcpreplay

发现系统仍然报错:

Is this ok [y/d/N]: y

Downloading packages:

  File “/usr/libexec/urlgrabber-ext-down”, line28    except OSError, e:

                  ^SyntaxError: invalid syntax

找到该文件[root@vnode33 libexec]# vi /usr/libexec/urlgrabber-ext-down

修改/usr/bin/python为/usr/bin/python2.7

可以安装成功了:

Is this ok [y/d/N]: y

Downloading packages:

tcpreplay-4.1.1-1.el7.x86_64.rpm                                                                                                                |298kB00:00:00   

Running transaction check

Running transaction test

Transaction test succeeded

Running transaction

  Installing : tcpreplay-4.1.1-1.el7.x86_641/1

  Verifying  : tcpreplay-4.1.1-1.el7.x86_641/1

Installed:

  tcpreplay.x86_64 0:4.1.1-1.el7                                                                                                                                     

Complete!

 或者也可以用以下的方法:

./configure –prefix=/opt/python    #因为centos自带python,为了不影响原有系统,我这里是另外安装到新目录makeinstall  进行安装ln-s /opt/python/bin/python3.4/usr/bin/python3  #软连接到系统path所指向的一个目录中,使之成为系统命令ln-s /opt/python/bin/pip3.4/usr/bin/pip3ln-s /opt/python/bin/easy_install-3.4/usr/bin/easy_install3

(二)安装pip3:

(1)首先下载,安装依赖setuptools

wget–no-check-certificate  https://pypi.python.org/packages/source/s/setuptools/setuptools-19.6.tar.gz#md5=c607dd118eae682c44ed146367a17e26tar-zxvf setuptools-19.6.tar.gz

cd setuptools-19.6.tar.gz

python3 setup.py build

python3 setup.py install

(2)安装pip3

1wget–no-check-certificate https://pypi.python.org/packages/source/p/pip/pip-8.0.2.tar.gz#md5=3a73c4188f8dbad6a1e6f6d44d117eeb2tar-zxvf pip-8.0.2.tar.gz3cd pip-8.0.24python3 setup.py build5python3 setup.pyinstall

安装完成之后我们再来查看python3.5的bin目录下都有什么东西:

1[root@vnode33 usr]# cd /usr/local/python3.5/bin/2[root@vnode33 bin]#ls32to3      easy_install      idle3    pip  pip3.5pydoc3.5python3.5python3.5m        python3-config  pyvenv-3.542to3-3.5easy_install-3.5idle3.5pip3  pydoc3  python3  python3.5-config  python3.5m-config  pyvenv

为pip3创建链接:

[root@vnode33 bin]#ln-s /usr/local/python3.5/bin/pip3 /usr/bin/pip

现在可以用了:

[root@vnode33 bin]# pip

Usage: 

  pip [options]

Commands:

  install                    Install packages.

  download                    Download packages.

  uninstall                  Uninstall packages.

  freeze                      Output installed packages in requirements format.

  list                        List installed packages.

  show                        Show information about installed packages.

  search                      Search PyPI for packages.

  wheel                      Build wheels from your requirements.

  hash                        Compute hashes of package archives.

  help                        Show help for commands.

(3)安装Twisted

Linux上设置https proxy并安装:

本机因从网络下载包时需要代理,故需要如下命令:

1export https_proxy=135.251.33.31:80802export http_proxy=135.251.33.31:80803export ftp_proxy=135.251.33.31:8080

然后下载安装:

1wgethttps://pypi.python.org/packages/source/T/Twisted/Twisted-15.2.1.tar.bz22tar-xjvf Twisted-15.2.1.tar.bz23cd Twisted-15.2.1/4python setup.pyinstall

检查是否安装成功:

1[root@vnode33 ~]# python2Python3.5.0(default, Feb162017,12:30:39) 3[GCC4.8.520150623(Red Hat4.8.5-4)] on linux4Type”help”,”copyright”,”credits”or”license”formore information.5>>> import twisted6>>>

(4)安装Scrapy

pipinstallScrapy

这个时候安装成功了,但是运行scrapy时报错

再重新安装下Twisted最新的版本:

1wgethttps://twistedmatrix.com/Releases/Twisted/17.1/Twisted-17.1.0.tar.bz22tar-xjvf Twisted-17.1.0.tar.bz23cd Twisted-17.1.0/4python setup.pyinstall

再运行scrapy发现已经好了:

[root@vnode33 bin]# ./scrapy

Scrapy 1.3.2- no active project

Usage:

  scrapy [options] [args]

Available commands:

  bench        Run quick benchmark test

  commands     

  fetch        Fetch a URL using the Scrapy downloader

  genspider    Generate new spider using pre-defined templates

  runspider    Run a self-contained spider (without creating a project)

  settings      Get settings values

  shell        Interactive scraping console

  startproject  Create new project

  version      Print Scrapy version

  view          Open URL in browser, as seen by Scrapy

  [ more ]      More commands available when run from project directory

Use “scrapy -h”to seemoreinfoabout a command

还需要做一个软链接让scrapy命令全局可用:

ln-s /usr/local/python3.5/bin/scrapy /usr/bin/scrapy

试试在Python中导入scrapy:

1Python3.5.0(default, Feb162017,12:30:39) 2[GCC4.8.520150623(Red Hat4.8.5-4)] on linux3Type”help”,”copyright”,”credits”or”license”formore information.4>>> from scrapy.spider import BaseSpider5__main__:1: ScrapyDeprecationWarning: Module scrapy.spider is deprecated, use scrapy.spiders instead6>>> from scrapy.spiders import BaseSpider

安装scrapy过程中有三步不确定是否需要,附录如下:

1,libxml2

wgetftp://xmlsoft.org/libxml2/libxml2-git-snapshot.tar.gztar-zxvf libxml2-git-snapshot.tar.gz

cd libxml2-2.9.2/./configuremakemakeinstall

2,libxlst

wgethttp://xmlsoft.org/sources/libxslt-1.1.28.tar.gztar-zxvf libxslt-1.1.28.tar.gz

cd libxslt-1.1.28/./configuremakemakeinstall

3,cryptography

wgetftp://sourceware.org/pub/libffi/libffi-3.2.1.tar.gztar-zxvf libffi-3.2.1.tar.gz

cd libffi-3.2.1./configuremakemakeinstall

export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:$PKG_CONFIG_PATH

wgetftp://sourceware.org/pub/libffi/libffi-3.2.1.tar.gztar-zxvf libffi-3.2.1.tar.gz

cd libffi-3.2.1./configuremakemakeinstall

Windows7下安装scrapy:

先下载python-3.5.2.exe 双击文件安装成功:

然后直接安装scrapy,找到pip文件的目录:

cd C:UsersxxxAppDataLocalProgramsPythonPython35-32Scripts

pipinstallscrapy

安装成功后测试下:

C:Usersxxx>python

Python 3.5.2(v3.5.2:4def2a2901a5, Jun252016,22:01:18) [MSC v.190032 bit (In

tel)] on win32

Type “help”,”copyright”,”credits”or”license”formore information.>>> from scrapy.spiders import BaseSpider>>> exit()

(三)IDLE支持方向键:

(1)安装readline

pipinstallreadline

但是有如下报错:

gcc: error: readline/libreadline.a: No suchfileor directory

解决方法:

yuminstallreadline-develyuminstallpatch

再重新configure、make、makeinstallpython3.5

出处:https://www.cnblogs.com/z-joshua/p/5710698.html

文章来源于互联网,如有雷同请联系站长删除:linux python2 升级 python3

发表评论